<?php
// GENERATED CODE -- DO NOT EDIT!

// Original file comments:
// Copyright 2017 Google Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
namespace Google\Cloud\VideoIntelligence\V1beta2;

/**
 * Service that implements Google Cloud Video Intelligence API.
 */
class VideoIntelligenceServiceGrpcClient extends \Grpc\BaseStub {

    /**
     * @param string $hostname hostname
     * @param array $opts channel options
     * @param \Grpc\Channel $channel (optional) re-use channel object
     */
    public function __construct($hostname, $opts, $channel = null) {
        parent::__construct($hostname, $opts, $channel);
    }

    /**
     * Performs asynchronous video annotation. Progress and results can be
     * retrieved through the `google.longrunning.Operations` interface.
     * `Operation.metadata` contains `AnnotateVideoProgress` (progress).
     * `Operation.response` contains `AnnotateVideoResponse` (results).
     * @param \Google\Cloud\VideoIntelligence\V1beta2\AnnotateVideoRequest $argument input argument
     * @param array $metadata metadata
     * @param array $options call options
     */
    public function AnnotateVideo(\Google\Cloud\VideoIntelligence\V1beta2\AnnotateVideoRequest $argument,
      $metadata = [], $options = []) {
        return $this->_simpleRequest('/google.cloud.videointelligence.v1beta2.VideoIntelligenceService/AnnotateVideo',
        $argument,
        ['\Google\LongRunning\Operation', 'decode'],
        $metadata, $options);
    }

}
